// menu.cpp

#include "data.h"
#include "database.h"
#include "category.h"
#include "help.h"
#include "menu.h"
#include<fstream>
#include<string>
#include<vector>
#include<iostream>
using namespace std;


Database *db = new Database;

void  Menu::main_menu(string opnad_fil)
{

	db->lasafil(opnad_fil); // lser in kategorier och dat

	char s;
	
  do{
  	cout << endl;
  	cout << "The Main Menu" << endl;
		cout << "Select [c] to go to categories menu" << endl;
		if (db->cat.sizeCategory()>0) // data_menu() finns bara om det finns kategorier
			cout << "select [d] to go to data menu" << endl;
		cout << "Select [x] to exit regprg" << endl;
		cout << ">";
		cin >> s;
	if (s=='c')
		cat_menu();
		
	if (s=='d')
		data_menu();
		
	}while (s != 'x');
	
	if (s=='x')
	{
		delete db;
		exit(0);
	}
	

}
// Menyer fr kategorihantering

void  Menu::cat_menu() // Kategorierna visas. ndra eller lgg till kategorier.
{
	char s;
	cout << endl;
	cout << "The Category Menu" << endl;
	cout << "current categories:" << endl;
	for (int i=0;i < db->cat.sizeCategory();i++)
		cout << db->cat.getCategory(i) << endl;
		
	do{
		cout << endl;
		cout << "Select [a] to add a new category" << endl;
		if (db->cat.sizeCategory()>0) // kategorier kan endast editeras eller tas bort om det finns ngon!
			cout << "select [e] to edit or delete a category" << endl;
		cout << "Select [m] to exit to the main menu" << endl;
		cout << "Select [x] to exit regprg" << endl;
		cout << ">";
		cin >> s;

	
	if (s=='x')
	{
		delete db;
		exit(0);
	}
	
	if (s=='m')
		return; //main_menu();
		
	if (s=='a')
		cat_add();
	if (db->cat.sizeCategory()>0)
	{	
		if (s=='e')
			cat_choose();
	}	

	}while (s != 'm' && s != 'x');
		
}

void Menu::cat_add() // Lgg till ny kategori.
{
	string s;
	cin.ignore();
	cout << endl;
	cout << "The Add Category Menu" << endl;
	cout << "New category to add:" << endl;
	cout << ">";
	
	getline(cin,s);

	db->addCat(s); // addCategory(string) Infogar ny kategory. Nya tomma dataposter skapas
}

void  Menu::cat_choose() // Vlj en kategori att editera eller radera.
{
	cout << "The Select Category Menu" << endl;
	int i,j;
	do {
		for (i=0;i < db->cat.sizeCategory();i++)
			cout << "Choose [" << i << "] for " << db->cat.getCategory(i) << endl;
		cout << ">";
		if (!(cin>>j)) // kollar fr inmatning av icke int.
		{
			j=(-1); // Skerstller att loopen fortstter.
			cin.clear();
			cin.ignore(numeric_limits<streamsize>::max(), '\n');
		}

	}while (j<0 || j>i);
	
	cat_del_edit(j);
}

void  Menu::cat_del_edit(int i) // Editera eller ta bort en kategori.
{
	char s;
	do {
	cout << endl;
	cout << "The Select edit/delete Category Menu" << endl;
	cout << "Do you want to [e] edit or do you want to [d] delete \"" << db->cat.getCategory(i) << "\"" << endl;
	cout << ">";
	cin >> s;

	if (s=='e')
		cat_edit(i);
	if (s=='d')
		cat_delete(i);
	
	}while (s!='e' && s!='d' && s!='c');
}



void  Menu::cat_edit(int i) // Editera en kategori.
{
	string s;
	cout << endl;
	cout << "The Edit Category Menu" << endl;
	cout << "New name for the category \"" << db->cat.getCategory(i) << "\"" << endl;
	cout << ">";
	cin >> s;
	db->cat.editCategory(i, s); // setCategory(int, string) Byter namn p kategori

}

void  Menu::cat_delete(int i) // Ta bort en kategori.
{
	char s;
	do {
		cout << endl;
		cout << "The Delete Category Menu" << endl;
		cout << "Are you sure you want to delete \"" << db->cat.getCategory(i) << "\"? [y] / [n]" << endl;
		cout << "All data will be lost" << endl;
		cout << ">";
		cin >> s;

	}while (s != 'y' && s != 'n');
	if (s=='y')
	{
		db->cat.deleteCategory(i); // setCategory(int) Tar bort kategori
		db->deleteCorrData(i); // Korresponderande data tas bort
		
	}	

}


// MENYER FR DATAHANTERING

void  Menu::data_menu()
{

	char s;
  do{
	
			cout << "The Data Menu" << endl;
			cout << "Select [a] to add a new a post" << endl;
			if (db->dat.sizeData()>0) // Bara om det finns ngot
			{
					cout << "Select [e] to edit an item or delete a post" << endl;
					cout << "Select [s] to search for an item" << endl;
			}
			cout << "Select [m] to exit to the main menu" << endl;
			cout << "Select [x] to exit regprg" << endl;
			cout << ">";
			cin >> s;

	
		if (s=='x')
		{
			delete db;
			exit(0);
		}
	
		if (s=='m')
			return; //main_menu();
			
					
		if (s=='a')
			data_add();
		if (db->dat.sizeData()>0) 
		{
			if (s=='e')
				data_choose();
				
			if (s=='s')
				data_seek();
		}
			

	
			}while (1==1); // Frga: r det "fult" att gra s hr?
	
	
}



void  Menu::data_add()
{
  string s;
  cin.ignore();
  int i=0;
  do{
  
 

	cout << endl;
	cout << "The Add Data Menu" << endl;
	cout << "New data to add in category \"" << db->cat.getCategory(i++) << "\"" << endl;
	
		cout << ">";
	
	getline(cin,s);
	db->dat.addData(s); 

	if (i==db->cat.sizeCategory()) // Nr aktuell post r klar kan man brja en ny post.
	{
		i=0;
		cout << "Do you want to [a] add one more post" << endl;
		cout << "or [r] return to data menu?" << endl;
		cout << ">";
		char c;
		cin  >> c;
        cin.ignore(); //Samma sak?		
		if (c!='a')
			return;
	}
	
	}while (1==1);

}

void  Menu::data_choose() // Visar data som kan editeras /poster som kan tas bort.
{
		int k=0;
		int m;
		
				cout << "The Select Data Menu";

			do{
					cout << endl;
					for (int j=0;j < db->cat.sizeCategory();j++)
					{
						
						cout << "[" << k << "]: \"" << db->cat.getCategory(j) << "\" \"" << db->dat.getData(k) << "\"" << endl;
						k++;
					}
					
			}while (k < db->dat.sizeData());
			cout << "\nSelect no. [0] - [" << k-1 << "] for edit or delete\n";
			cout << "or [" << k << "] to return to Data Menu\n";
  do{	
 

		cout << ">";	

		if (!(cin>>m)) // kollar fr inmatning av icke int.
		
			{
				m=(-1); // Skerstller att loopen fortstter.
				cin.clear();
				cin.ignore(numeric_limits<streamsize>::max(), '\n');
		    }

	}while (m<0 || m>k);
	if (k==m)
		return;
	data_edit(m);

}

		


	
void  Menu::data_seek() // Skning
{
	cout << "The Search Data Menu" << endl;
	int i,j;
	string s;
	char c;
	for (i=0;i<db->cat.sizeCategory();i++)
	{	cout << "Select [" << i << "] for " << db->cat.getCategory(i) << endl;}
		cout << "Select [" << i << "] for all categories" << endl;
	do{
	
		cout << ">";
		if (!(cin>>j)) // kollar fr inmatning av icke int.
		{
			j=(-1); // Skerstller att loopen fortstter.
			cin.clear();
			cin.ignore(numeric_limits<streamsize>::max(), '\n');
		}
	
	}while (j<0 || j>i);
	
	cin.ignore();
	if (j<db->cat.sizeCategory()) // sk i en eller alla kategorier
		cout << "The string to search for in category " << "\"" << db->getCorrespondingCategory(j) << "\"" << endl;
	else
		cout << "The string to search for in \"All Categories\"" << endl;
	cout << ">";
	getline(cin,s);
	
	

	
	vector<int> *h = db->seek(j,s,exact_match()); // Skresultatet lagras i en vektor. Kollar om det skall vara exakt matchning
	vector<int>::iterator it;
	if (h->size()<=0)
		cout << "\nSEARCH STRING NOT FOUND\n\n";
else
{
	
		cout << "This items where found:" << endl;
		for (it=h->begin();it<h->end();it++)
			cout << "[" <<  *it << "] " << db->dat.getData(*it) << endl;
		cout << endl;
	do{

	cout << "Do yuo wish to see all posts for these items?\n";
	cout << "Type [v] to view complete post/posts\n";
	cout << "or [d] to return to Data Menu\n";
	cout << ">";	
	cin >> c;
	if (c=='r')
	{
		delete h;
		h=0;
		return;
	}
	}
	while(c != 'r' && c != 'v');
		cout << endl;
	bool del=false;	
	for (it=h->begin();it<h->end();it++)
	{
		post_find(*it,del);
	}
	cout << endl;
}

	delete h;
	h=0;
		
}
	




void  Menu::data_edit(int i) // ndrar data
{
	cout << "\nThe Edit / Delete Data Menu";
	char c;
	cout << endl;
	cout << "Do you want to delete [d] the complete post containing\n\"" << db->dat.getData(i) << "\" (Item no. " << i << ")\n"; 
	cout << "or edit [e] this item?\n";
	cout << ">";
	do{

		cin >> c;
	}while (c!='d' && c!='e');
	
	if (c=='e')
		item_edit(i);
	if (c=='d')
	{
		bool del=true;
		post_find(i,del);
	}

}


void  Menu::post_find(int post, bool del)
{
		int possition = db->getCorrespondingCategory(post);
		int start_post=post-possition;
		cout << endl;

		vector<int> *this_post = new vector<int>;
		for (int i=0;i<db->cat.sizeCategory();i++)
		{	

			cout << "Category: " << "\"" << db->cat.getCategory(i) << "\" Data \"" << db->dat.getData(start_post) << "\"" << endl;
			this_post->push_back(start_post);
			start_post++;
			
			
			
		}
		if (del==true) // Anvnds som hjlpfunktion av tv andra funktioner.
			post_del(this_post); // Den ena skall ta bort bort poster, drfr detta boolska vilkor. Frga: r det bra?
}

void  Menu::post_del(vector<int> *this_post)
{
	cout << "Are you sure you want to delete this post [y] / [n]" << endl;
	cout << ">";
	char c;
	do{
		cin >> c;
	}while(c!='y' && c!='n');
	if (c=='n')
	{
		delete this_post;
		this_post=0;
		return;
	}
	vector<int>::iterator it;
	for (it=this_post->begin();it<this_post->end();it++)
		db->dat.deleteData(*it); // plockar ur vektor och skickar fr borttagning
	delete this_post;
	this_post=0;
		
}

void  Menu::item_edit(int post) // Data fr nytt vrde
{
	int category = db->getCorrespondingCategory(post);
	string s;
	cout << "New data instead of \"" << db->dat.getData(post) << "\"" << " In category \"" << db->cat.getCategory(category) << "\"" << endl;
	cout << ">";
	cin.ignore(1,'\n');
	getline(cin,s);
	db->dat.editData(post, s); 


}


bool  Menu::exact_match() // skall det vara exakt matchning?
{		   // besked genom konfigurationsfil eller frn anvndaren.
	
	Help *hlp = new Help;
	string *configure=hlp->getConf("exactmatch");
	
	if (*configure=="no")
	{
		delete configure;
		configure=0;
		delete hlp;
		hlp=0;
		return false;
	}
	
	if (*configure=="yes")
	{
		delete configure; // Frga: Om pekare och delete
		configure=0;
		delete hlp;
		hlp=0;
		return true;
	}
		
		
	char c;
	cout << "[e] Exact match" << endl;
	cout << "[p] Partial match" << endl;
	do{
		cout << ">";
		cin >> c;
		if (c=='e')
			return true;
		else
			return false;
	}while(c != 'e' && c != 'p');
	
}
